MageBombTracker = {} 

MBTrackerLSM = LibStub("LibSharedMedia-3.0") 

MBTracker_UpdateInterval = 0.1; -- How often the OnUpdate code will run (in seconds)

--local MBTlvb, MBTlvbID, mbtlbraidcheck, mbtlbtablerefresh
local mbtlbrefresh, mbtlbraidcheck, mbtlbtablerefresh, mbtlbgroupsuffix, mbtlbtargetsuffix, mbtlbgroupnumber, mbtrackerenableheight--, mbtrackerenableclean, mbtrackerenablemax
local timestamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, spellId, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, critical 
local mbtpotentialrefresh, mbtrefreshdone, mbtrefreshGUID, mbtrefreshname

function MBTracker_OnLoad() 
                                               
    if select(2, UnitClass("player")) ~= "MAGE" then MBTrackerVarReset() MBTrackerFrame:Hide() return end
        
	MBTrackerFrame:RegisterForDrag("LeftButton")
	MBTrackerFrame:RegisterEvent("PLAYER_LOGIN")
	MBTrackerFrame:RegisterEvent("PLAYER_REGEN_DISABLED")
	MBTrackerFrame:RegisterEvent("PLAYER_REGEN_ENABLED")
 	MBTrackerFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
 	MBTrackerFrame:RegisterEvent("PLAYER_TALENT_UPDATE")
 	MBTrackerFrame:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
 
 	MBTrackerLSM.RegisterCallback(MageBombTracker , "LibSharedMedia_Registered", "SharedMedia_Registered") 

	MBTrackerLSM:Register("background","Blizzard Tooltip","Interface\\Tooltips\\UI-Tooltip-Background")
	MBTrackerLSM:Register("border","Blizzard Tooltip","Interface\\Tooltips\\UI-Tooltip-Border")
	MBTrackerLSM:Register("border","ElvUI Border","Interface\\AddOns\\MageBombTracker\\Images\\ElvUIBorder")
	MBTrackerLSM:Register("statusbar","CombuBar","Interface\\AddOns\\MageBombTracker\\Images\\combubarblack")
        
    MBTrackerLanguageCheck()
	MBTrackerTableCopy()
	MBTrackerVarReset()
    MBTrackerBombChecker()
    
end

MBTrackertable = {}
                            
mbtrackerdefaultsettingstable = {["mbtrackerlock"] = false,
							["mbtrackerautohide"] = 1,
							["mbtrackerscale"] = 1,
							["mbtrackerrefreshmode"] = true,
							["mbtrackerchat"] = true,
							["mbtrackerenable"] = true,
							["mbtrackertarget"] = true,
							["mbtrackerflamestrike"] = true,
							["mbtrackertexturename"] = "CombuBar",
							["mbtrackerfontname"] = "Friz Quadrata TT",
							["barcolornormal"] = {0,0.5,0.8,1},
							["barcolorwarning"] = {1,0,0,1},
							["textcolornormal"] = {1,1,1,1},
							["textcolorwarning"] = {1,0,0,1},
							["bgcolornormal"] = {0.25,0.25,0.25,1},
							["edgecolornormal"] = {0.67,0.67,0.67,1},
							["bgFile"] = "Blizzard Tooltip",
                        	["tileSize"] = 16,
                        	["edgeFile"] = "Blizzard Tooltip",
                        	["tile"] = true,
                        	["edgeSize"] = 16,
                        	["insets"] = 5,
                            ["language"] = "Default",
							["mbtrackertimervalue"] = 2,
                            ["direction"] = "downward",
}

function MBTrackerLanguageCheck()

    if mbtrackersettingstable then 
    
        if mbtrackersettingstable["language"] == "Francais" or mbtrackersettingstable["language"] == "Default" and GetLocale() == "frFR" then

            MBTrackerLoc = MBTrackerLocFR
            mbtrackeroptioninfotable = mbtrackeroptioninfotableFR
            MBTrackerOptLoc = MBTrackerOptLocFR
            MBTrackerLBposition = MBTrackerLBpositionFR
            MBTrackerAutohideList = MBTrackerAutohideListFR
            MBTrackerLabel = MBTrackerLabelFR
                
--~         elseif mbtrackersettingstable["language"] == "Deutsch" or mbtrackersettingstable["language"] == "Default" and GetLocale() == "deDE" then
--~             
--~             MBTrackerLoc = MBTrackerLocDE
--~             mbtrackeroptioninfotable = mbtrackeroptioninfotableDE
--~             MBTrackerOptLoc = MBTrackerOptLocDE
--~             MBTrackerLBposition = MBTrackerLBpositionDE
--~             MBTrackerAutohideList = MBTrackerAutohideListDE
--~             MBTrackerLabel = MBTrackerLabelDE
--~             
--~         elseif mbtrackersettingstable["language"] == "Chinese" or mbtrackersettingstable["language"] == "Default" and GetLocale() == "zhTW" then
--~             
--~             MBTrackerLoc = MBTrackerLocTW
--~             mbtrackeroptioninfotable = mbtrackeroptioninfotableTW
--~             MBTrackerOptLoc = MBTrackerOptLocTW
--~             MBTrackerLBposition = MBTrackerLBpositionTW
--~             MBTrackerAutohideList = MBTrackerAutohideListTW
--~             MBTrackerLabel = MBTrackerLabelTW

        else MBTrackerLoc = MBTrackerLocEN
            mbtrackeroptioninfotable = mbtrackeroptioninfotableEN
            MBTrackerOptLoc = MBTrackerOptLocEN
            MBTrackerLBposition = MBTrackerLBpositionEN
            MBTrackerAutohideList = MBTrackerAutohideListEN
            MBTrackerLabel = MBTrackerLabelEN

        end
        
    else MBTrackerLoc = MBTrackerLocEN
        mbtrackeroptioninfotable = mbtrackeroptioninfotableEN
        MBTrackerOptLoc = MBTrackerOptLocEN
        MBTrackerLBposition = MBTrackerLBpositionEN
        MBTrackerAutohideList = MBTrackerAutohideListEN
        MBTrackerLabel = MBTrackerLabelEN
        
   end

end

function MBTrackerTableCopy()

	mbtrackersettingstable = {}
	
	for k,v in pairs(mbtrackerdefaultsettingstable) do 
		if type(v) == "table" then
			mbtrackersettingstable[k] = {}
			for i = 1,#v do
				table.insert(mbtrackersettingstable[k],v[i])
			end
		else mbtrackersettingstable[k] = v 
		end
	end
    
end

----------------------------------
-- Helper function to reset some variables
function MBTrackerVarReset()

   	mbtlbrefresh = 0
    mbtrackerenableclean = false
    mbtrackerenablemax = 0
    mbtrackerenableheight = 0
    mbtpotentialrefresh = 0
    mbtrefreshdone = 0
    
end

--------------------------------
-- Helper function for Sharemedia support
function MageBombTracker:SharedMedia_Registered()
--	print("prut")
    -- do whatever needs to be done to repaint / refont
end

-------------------------------
-- helper function for option panel setup
function MageBombTrackerOptions_OnLoad(panel)
    MBTrackerLanguageCheck()
	panel.name = "MageBombTracker"
	InterfaceOptions_AddCategory(panel);
end

-------------------------------
-- lock function for option panel
function MBTrackerlock()

	if MBTrackerlockButton:GetChecked(true) then mbtrackersettingstable["mbtrackerlock"] = true 
                                 MBTrackerFrame:EnableMouse(false)
                                 MBTrackerlockButton:SetChecked(true)
                                 if (mbtrackersettingstable["mbtrackerchat"]==true) then ChatFrame1:AddMessage(MBTrackerLoc["lockon"]) end
	else mbtrackersettingstable["mbtrackerlock"] = false 
         MBTrackerFrame:EnableMouse(true)
         MBTrackerlockButton:SetChecked(false)
         if (mbtrackersettingstable["mbtrackerchat"]==true) then ChatFrame1:AddMessage(MBTrackerLoc["lockoff"]) end
	end
end

-------------------------------
-- chat function for option panel
function MBTrackerchat()

	if MBTrackerchatButton:GetChecked(true) then mbtrackersettingstable["mbtrackerchat"] = true 
                                 MBTrackerchatButton:SetChecked(true)
                                 ChatFrame1:AddMessage(MBTrackerLoc["reporton"])
	else mbtrackersettingstable["mbtrackerchat"] = false 
         MBTrackerchatButton:SetChecked(false)
	end
end

-------------------------------
-- Bombs refresh function for option panel
function MBTrackerrefresh()

	if MBTrackerrefreshButton:GetChecked(true) then mbtrackersettingstable["mbtrackerrefreshmode"] = true 
                                                MBTrackerrefreshButton:SetChecked(true)
                                                if (mbtrackersettingstable["mbtrackerchat"]==true) then ChatFrame1:AddMessage(MBTrackerLoc["lbon"]) end
	else mbtrackersettingstable["mbtrackerrefreshmode"] = false 
         MBTrackerrefreshButton:SetChecked(false)
         if (mbtrackersettingstable["mbtrackerchat"]==true) then ChatFrame1:AddMessage(MBTrackerLoc["lboff"]) end
	end
end

-------------------------------
-- Scale function for option panel
function MBTrackerScale (scale)

	MBTrackerFrame:SetScale(scale)
	mbtrackersettingstable["mbtrackerscale"] = scale
end

-------------------------------
-- Flamestrike mode function for option panel
function MBTrackerFlamestrike()

	if MBTrackerFlamestrikeButton:GetChecked(true) then mbtrackersettingstable["mbtrackerflamestrike"] = true 
                                                 	MBTrackerFlamestrikeButton:SetChecked(true)
                                             		if (mbtrackersettingstable["mbtrackerchat"]==true) then ChatFrame1:AddMessage(MBTrackerLoc["fson"]) end
	else mbtrackersettingstable["mbtrackerflamestrike"] = false 
         MBTrackerFlamestrikeButton:SetChecked(false)
         if (mbtrackersettingstable["mbtrackerchat"]==true) then ChatFrame1:AddMessage(MBTrackerLoc["fsoff"]) end
	end
end

-------------------------------
-- living bomb tracker target mode function for option panel
function MBTrackertarget()

	if MBTrackertargetButton:GetChecked(true) then mbtrackersettingstable["mbtrackertarget"] = true 
                                                 MBTrackertargetButton:SetChecked(true)
	else mbtrackersettingstable["mbtrackertarget"] = false 
         MBTrackertargetButton:SetChecked(false)
	end
end

-------------------------------
-- Multiple Living Bomb tracker function for option panel
function MBTracker()

	if MBTrackerButton:GetChecked(true) then mbtrackersettingstable["mbtrackerenable"] = true 
                                             MBTrackerButton:SetChecked(true)
                                             MBTrackerFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
                                             MBTrackerFrame:RegisterEvent("PLAYER_TALENT_UPDATE")
                                             if (mbtrackersettingstable["mbtrackerchat"]==true) then ChatFrame1:AddMessage(MBTrackerLoc["lbtrackon"]) end
	else mbtrackersettingstable["mbtrackerenable"] = false 
         MBTrackerButton:SetChecked(false)
         table.wipe(MBTrackertable)
         MBTrackerFrame:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
         MBTrackerFrame:UnregisterEvent("PLAYER_TALENT_UPDATE")
         if (mbtrackersettingstable["mbtrackerchat"]==true) then ChatFrame1:AddMessage(MBTrackerLoc["lbtrackoff"]) end
	end
    
    MBTrackerFrameresize()
    
end

function MBTrackerBackdropBuild ()

	if not MBTrackerBackdrop then
	
		MBTrackerBackdrop = {bgFile="Interface\\Tooltips\\UI-Tooltip-Background",
                        tileSize=16,
                        edgeFile="Interface\\Tooltips\\UI-Tooltip-Border",
                        tile=true,
                        edgeSize=16,
                        insets={
                          top=5,
                          right=5,
                          left=5,
                          bottom=5}}
    end

    if mbtrackersettingstable then
        MBTrackerBackdrop["bgFile"] = MBTrackerLSM:Fetch("background",mbtrackersettingstable["bgFile"])
        MBTrackerBackdrop["tileSize"] = mbtrackersettingstable["tileSize"]
        MBTrackerBackdrop["edgeFile"] = MBTrackerLSM:Fetch("border",mbtrackersettingstable["edgeFile"])
        MBTrackerBackdrop["tile"] = mbtrackersettingstable["tile"]
        MBTrackerBackdrop["edgeSize"] = mbtrackersettingstable["edgeSize"];
        (MBTrackerBackdrop["insets"])["top"] = mbtrackersettingstable["insets"];
        (MBTrackerBackdrop["insets"])["right"] = mbtrackersettingstable["insets"];
        (MBTrackerBackdrop["insets"])["left"] = mbtrackersettingstable["insets"];
        (MBTrackerBackdrop["insets"])["bottom"] = mbtrackersettingstable["insets"]
    end
    
    MBTrackerBorderFrame:SetBackdrop(MBTrackerBackdrop)
    MBTrackerBorderFrame:SetBackdropColor(unpack(mbtrackersettingstable["bgcolornormal"]))
    MBTrackerBorderFrame:SetBackdropBorderColor(unpack(mbtrackersettingstable["edgecolornormal"]))

end
			
-------------------------------
-- Helper function for frame resizing
function MBTrackerFrameresize()
	
	if mbtrackersettingstable["mbtrackerenable"] == true and select(2, UnitClass("player")) == "MAGE" then
		 MBTrackerFrame:Show() --print("show")
	else MBTrackerFrame:Hide() --print("hide")
	end

	if mbtrackerenablemax and mbtrackerenablemax > 0 then 
		
		for i = 1,mbtrackerenablemax do 

			if _G["MBTrack"..i] then
				
				_G["MBTrack"..i.."InfoText"]:SetWidth(MBTrackerFrame:GetWidth()-41)
				_G["MBTrack"..i.."InfoText"]:SetFont(MBTrackerLSM:Fetch("font",mbtrackersettingstable["mbtrackerfontname"]), select(2,_G["MBTrack"..i.."InfoText"]:GetFont()))
				_G["MBTrack"..i.."InfoTimer"]:SetFont(MBTrackerLSM:Fetch("font",mbtrackersettingstable["mbtrackerfontname"]), select(2,_G["MBTrack"..i.."InfoTimer"]:GetFont()))
				_G["MBTrack"..i.."Bar"]:SetWidth(MBTrackerFrame:GetWidth()-12)
				_G["MBTrack"..i.."Bar"]:SetMinMaxValues(0,100)
				_G["MBTrack"..i.."Bar"]:SetStatusBarTexture(MBTrackerLSM:Fetch("statusbar",mbtrackersettingstable["mbtrackertexturename"]))
                
    		end
    	end 
    end

	MBTrackerBackdropBuild ()
    MBTrackerFrame:SetFrameLevel(MBTrackerBorderFrame:GetFrameLevel())
    MBTrackerBorderFrame:SetFrameLevel(MBTrackerFrame:GetFrameLevel())

    MBTrackerAutohide()
    
end

function MBTrackerreset ()

	MBTrackerFrame:ClearAllPoints()
	MBTrackerFrame:SetPoint("CENTER", UIParent, "CENTER" ,0,0)
	MBTrackerFrame:SetScale(1)
	
	MBTrackerTableCopy()
	
	ChatFrame1:AddMessage(MBTrackerLoc["reset"])
	MBTrackerFrameresize()
	MBTrackerlock ()

end
	
function MBTrackerColorPicker(r, g, b, a)

    --print(r, g, b, a)
    --print(mbtrackercolorinstance,unpack(mbtrackersettingstable[mbtrackercolorinstance]))

    ColorPickerFrame.hasOpacity, ColorPickerFrame.opacity = (a ~= nil), a;
    ColorPickerFrame.previousValues = {r,g,b,a};
    ColorPickerFrame.func, ColorPickerFrame.opacityFunc, ColorPickerFrame.cancelFunc = MBTrackerColorCallback, MBTrackerColorCallback, MBTrackerColorCallback;
    ColorPickerFrame:SetColorRGB(r,g,b);
    ColorPickerFrame:Hide(); -- Need to run the OnShow handler.
    ColorPickerFrame:Show();
    
end

function MBTrackerColorCallback(restore)

	local newR, newG, newB, newA;
	
	if restore then
		newR, newG, newB, newA = unpack(restore);
	else newA, newR, newG, newB = OpacitySliderFrame:GetValue(), ColorPickerFrame:GetColorRGB();
	end
	 
	(mbtrackersettingstable[mbtrackercolorinstance])[1], (mbtrackersettingstable[mbtrackercolorinstance])[2], (mbtrackersettingstable[mbtrackercolorinstance])[3], (mbtrackersettingstable[mbtrackercolorinstance])[4] = newR, newG, newB, newA;
	_G["MBTracker"..mbtrackercolorinstance.."SwatchTexture"]:SetVertexColor(unpack(mbtrackersettingstable[mbtrackercolorinstance]))
    
    MBTrackerFrameresize()

end

function MBTrackerCreateTextureList(dropdown, settings)

    mbtrackertexturesettings = settings
    mbtrackertexturedropdown = dropdown
    
    MBTrackerTextureList = {} for k in pairs(MBTrackerLSM:HashTable("statusbar")) do tinsert(MBTrackerTextureList,k) end
    
    MBTrackerTextureBorderFrame:Show()
    MBTrackerTextureBorderFrame:ClearAllPoints()
    MBTrackerTextureFrame:SetHeight(#MBTrackerTextureList*20)
    MBTrackerTextureBorderFrame:SetPoint("CENTER",dropdown,"CENTER",0,0-(MBTrackerTextureFrame:GetHeight()/4))
    MBTrackerTextureBorderFrame:SetParent(dropdown)
    MBTrackerTextureBorderFrame:SetFrameLevel(_G[dropdown:GetName().."Button"]:GetFrameLevel()+1)
    MBTrackerTextureBorderFrame:SetScale(1.3)
    
    for i = 1,#MBTrackerTextureList do
    
        CreateFrame("button", "MBTrackerTexture"..i, MBTrackerTextureFrame, "MBTrackerTextureTemplate")
        
        if i == 1 then
            MBTrackerTexture1:ClearAllPoints()
            MBTrackerTexture1:SetPoint("TOP",MBTrackerTextureFrame,"TOP",0,0)
        else _G["MBTrackerTexture"..i]:ClearAllPoints()
             _G["MBTrackerTexture"..i]:SetPoint("TOP",_G["MBTrackerTexture"..i-1],"BOTTOM",0,0)
        end
        
        _G["MBTrackerTexture"..i.."Bar"]:SetTexture(MBTrackerLSM:Fetch("statusbar",MBTrackerTextureList[i]))
        _G["MBTrackerTexture"..i.."Bar"]:SetVertexColor(unpack(mbtrackersettingstable["barcolornormal"]))
        _G["MBTrackerTexture"..i.."Text"]:SetText(MBTrackerTextureList[i])
        
        if (MBTrackerTextureList[i]) == mbtrackersettingstable[settings] then
            _G["MBTrackerTexture"..i.."Text"]:SetTextColor(1,0.8,0.2,1)
        else _G["MBTrackerTexture"..i.."Text"]:SetTextColor(1,1,1,1)
        end
    
    end
    
end
            
function MBTrackerCreateFontList()

    MBTrackerFontList = {} for k in pairs(MBTrackerLSM:HashTable("font")) do tinsert(MBTrackerFontList,k) end
    
    MBTrackerFontBorderFrame:Show()
    MBTrackerFontBorderFrame:ClearAllPoints()
    MBTrackerFontFrame:SetHeight(#MBTrackerFontList*15)
    MBTrackerFontBorderFrame:SetPoint("CENTER",MBTrackerFontDropDown,"CENTER",0,0-(MBTrackerFontFrame:GetHeight()/4))
    MBTrackerFontBorderFrame:SetParent(MBTrackerFontDropDown)
    MBTrackerFontBorderFrame:SetFrameLevel(MBTrackerFontDropDownButton:GetFrameLevel()+1)
    MBTrackerFontBorderFrame:SetScale(1.3)
 
    for i = 1,#MBTrackerFontList do
    
        CreateFrame("button", "MBTrackerFont"..i, MBTrackerFontFrame, "MBTrackerFontTemplate")
        
        if i == 1 then
            MBTrackerFont1:ClearAllPoints()
            MBTrackerFont1:SetPoint("TOP",MBTrackerFontFrame,"TOP",0,0)
        else _G["MBTrackerFont"..i]:ClearAllPoints()
             _G["MBTrackerFont"..i]:SetPoint("TOP",_G["MBTrackerFont"..i-1],"BOTTOM",0,0)
        end
        
        _G["MBTrackerFont"..i.."Bar"]:SetTexture(MBTrackerLSM:Fetch("statusbar",mbtrackersettingstable["mbtrackertexturename"]))
        _G["MBTrackerFont"..i.."Bar"]:SetVertexColor(unpack(mbtrackersettingstable["barcolornormal"]))
        _G["MBTrackerFont"..i.."Text"]:SetText(MBTrackerFontList[i])
        _G["MBTrackerFont"..i.."Text"]:SetFont(MBTrackerLSM:Fetch("font",MBTrackerFontList[i]),9)
        
        if MBTrackerFontList[i] == mbtrackersettingstable["mbtrackerfontname"] then
            _G["MBTrackerFont"..i.."Text"]:SetTextColor(1,0.8,0.2,1)
        else _G["MBTrackerFont"..i.."Text"]:SetTextColor(1,1,1,1)
        end
    
    end
    
end

function MBTrackerCreateSoundList()

    MBTrackerSoundList = {} for k in pairs(MBTrackerLSM:HashTable("sound")) do tinsert(MBTrackerSoundList,k) end
    
    MBTrackerSoundBorderFrame:Show()
    MBTrackerSoundBorderFrame:ClearAllPoints()
    MBTrackerSoundFrame:SetHeight(#MBTrackerSoundList*15)
    MBTrackerSoundBorderFrame:SetPoint("CENTER",MBTrackerSoundDropDown,"CENTER",0,0-(MBTrackerSoundFrame:GetHeight()/4))
    MBTrackerSoundBorderFrame:SetParent(MBTrackerSoundDropDown)
    MBTrackerSoundBorderFrame:SetFrameLevel(MBTrackerSoundDropDownButton:GetFrameLevel()+1)
    MBTrackerSoundBorderFrame:SetScale(1.3)
 
    for i = 1,#MBTrackerSoundList do
    
        CreateFrame("button", "MBTrackerSound"..i, MBTrackerSoundFrame, "MBTrackerSoundTemplate")
        _G["MBTrackerSound"..i]:SetID(i)
        
        if i == 1 then
            MBTrackerSound1:ClearAllPoints()
            MBTrackerSound1:SetPoint("TOP",MBTrackerSoundFrame,"TOP",0,0)
        else _G["MBTrackerSound"..i]:ClearAllPoints()
             _G["MBTrackerSound"..i]:SetPoint("TOP",_G["MBTrackerSound"..i-1],"BOTTOM",0,0)
        end
        
        _G["MBTrackerSound"..i.."Text"]:SetText(MBTrackerSoundList[i])
        
        if MBTrackerSoundList[i] == mbtrackersettingstable["mbtrackersoundname"] then
            _G["MBTrackerSound"..i.."Text"]:SetTextColor(1,0.8,0.2,1)
        else _G["MBTrackerSound"..i.."Text"]:SetTextColor(1,1,1,1)
        end
    
    end
    
end

function MBTrackerCreateBorderList()

    MBTrackerBorderList = {} for k in pairs(MBTrackerLSM:HashTable("border")) do tinsert(MBTrackerBorderList,k) end
       
    MBTrackerEdgeBorderFrame:Show()
    MBTrackerEdgeBorderFrame:ClearAllPoints()
    MBTrackerEdgeFrame:SetHeight(#MBTrackerBorderList*32)
    MBTrackerEdgeBorderFrame:SetPoint("CENTER",MBTrackerBorderDropDown,"CENTER",0,0-(MBTrackerEdgeFrame:GetHeight()/4))
    MBTrackerEdgeBorderFrame:SetParent(MBTrackerBorderDropDown)
    MBTrackerEdgeBorderFrame:SetFrameLevel(MBTrackerBorderDropDownButton:GetFrameLevel()+1)
    MBTrackerEdgeBorderFrame:SetScale(1.3)
    
    for i = 1,#MBTrackerBorderList do
    
        CreateFrame("button", "MBTrackerBorder"..i, MBTrackerEdgeFrame, "MBTrackerEdgeTemplate")
        
        if i == 1 then
            MBTrackerBorder1:ClearAllPoints()
            MBTrackerBorder1:SetPoint("TOP",MBTrackerEdgeFrame,"TOP",0,0)
        else _G["MBTrackerBorder"..i]:ClearAllPoints()
             _G["MBTrackerBorder"..i]:SetPoint("TOP",_G["MBTrackerBorder"..i-1],"BOTTOM",0,0)
        end
        
        _G["MBTrackerBorder"..i.."Bar"]:SetTexture(MBTrackerLSM:Fetch("border",MBTrackerBorderList[i]))
        _G["MBTrackerBorder"..i.."Bar"]:SetVertexColor(unpack(mbtrackersettingstable["edgecolornormal"]))
        _G["MBTrackerBorder"..i.."Text"]:SetText(MBTrackerBorderList[i])
        
        if MBTrackerBorderList[i] == mbtrackerBorder then
            _G["MBTrackerBorder"..i.."Text"]:SetTextColor(1,0.8,0.2,1)
        else _G["MBTrackerBorder"..i.."Text"]:SetTextColor(1,1,1,1)
        end
    
    end
    
end

function MBTrackerCreateBackgroundList()

    MBTrackerBackgroundList = {} for k in pairs(MBTrackerLSM:HashTable("background")) do tinsert(MBTrackerBackgroundList,k) end
     
    MBTrackerBgBorderFrame:Show()
    MBTrackerBgBorderFrame:ClearAllPoints()
    MBTrackerBgFrame:SetHeight(#MBTrackerBackgroundList*30)
    MBTrackerBgBorderFrame:SetPoint("CENTER",MBTrackerBackgroundDropDown,"CENTER",0,0-(MBTrackerBgFrame:GetHeight()/4))
    MBTrackerBgBorderFrame:SetParent(MBTrackerBackgroundDropDown)
    MBTrackerBgBorderFrame:SetFrameLevel(MBTrackerBackgroundDropDownButton:GetFrameLevel()+1)
    MBTrackerBgBorderFrame:SetScale(1.3)
    
    for i = 1,#MBTrackerBackgroundList do
    
        CreateFrame("button", "MBTrackerBackground"..i, MBTrackerBgFrame, "MBTrackerBgTemplate")
        
        if i == 1 then
            MBTrackerBackground1:ClearAllPoints()
            MBTrackerBackground1:SetPoint("TOP",MBTrackerBgFrame,"TOP",0,0)
        else _G["MBTrackerBackground"..i]:ClearAllPoints()
             _G["MBTrackerBackground"..i]:SetPoint("TOP",_G["MBTrackerBackground"..i-1],"BOTTOM",0,0)
        end
        
        _G["MBTrackerBackground"..i.."Bar"]:SetTexture(MBTrackerLSM:Fetch("background",MBTrackerBackgroundList[i]))
        _G["MBTrackerBackground"..i.."Text"]:SetText(MBTrackerBackgroundList[i])
        
        if MBTrackerBackgroundList[i] == mbtrackerBackground then
            _G["MBTrackerBackground"..i.."Text"]:SetTextColor(1,0.8,0.2,1)
        else _G["MBTrackerBackground"..i.."Text"]:SetTextColor(1,1,1,1)
        end
    
    end
    
end

function MBTrackerCreateBombRow (row,create)

    if row and not _G["MBTrack"..row] then
        CreateFrame("frame", "MBTrack"..row, MBTrackerFrame, "MBTrackTemplate")
        _G["MBTrack"..row.."Bar"]:SetMinMaxValues(0,100)
        MBTrackerFrameresize()
    end
	
    if not create then
    
        for i = 1, mbtrackerenablemax do

			if _G["MBTrack"..i] then
			
				if mbtrackersettingstable["direction"] == "downward" then
	
					if i == 1 then
						MBTrack1:ClearAllPoints()
						MBTrack1:SetPoint("TOP",MBTrackerFrame,"TOP",0,-6)
					else _G["MBTrack"..i]:ClearAllPoints()
						_G["MBTrack"..i]:SetPoint("TOP",_G["MBTrack"..i-1],"BOTTOM",0,0)
					end
					
					MBTrackerBorderFrame:ClearAllPoints()
					MBTrackerBorderFrame:SetPoint("TOP",MBTrackerFrame,"TOP",0,0)
					
				elseif mbtrackersettingstable["direction"] == "upward" then
	
					if i == 1 then
						MBTrack1:ClearAllPoints()
						MBTrack1:SetPoint("BOTTOM",MBTrackerFrame,"BOTTOM",0,6)
					else _G["MBTrack"..i]:ClearAllPoints()
						_G["MBTrack"..i]:SetPoint("BOTTOM",_G["MBTrack"..i-1],"TOP",0,0)
					end
	
					MBTrackerBorderFrame:ClearAllPoints()
					MBTrackerBorderFrame:SetPoint("BOTTOM",MBTrackerFrame,"BOTTOM",0,0)
					
				end
			
			else MBTrackerCreateBombRow (i,1)
			end
		end
    end
	    
end

-------------------------------
--function for bomb type 
function MBTrackerBombChecker ()
		
	if select(2,GetTalentRowSelectionInfo(5)) == 13 then -- nether tempest selected
		
		MBTlvb = GetSpellInfo(114923)
		MBTlvbID = 114923
		
	elseif select(2,GetTalentRowSelectionInfo(5)) == 14 then -- living bomb
		
		MBTlvb = GetSpellInfo(44457)
		MBTlvbID = 44457
		
	elseif select(2,GetTalentRowSelectionInfo(5)) == 15 then -- frost bomb
		
		MBTlvb = GetSpellInfo(112948)
		MBTlvbID = 112948
	
	else MBTlvb = GetSpellInfo(44457)
		 MBTlvbID = 44457
	
	end

    --print(MBTlvb,MBTlvbID)
end

-------------------------------
--Helper function for living bomb tracking expiration time collecting
local function MBTrackerLBauratracker(targetguid, targetname, eventgettime)

	mbtlbraidcheck = 0
	mbtlbtablerefresh = 0
    mbtlbgroupsuffix = nil
    mbtlbtargetsuffix = nil
    
    if select(4,GetBuildInfo()) >= 50001 then 
    	
    	if GetNumSubgroupMembers() > 5 then
    	    mbtlbgroupsuffix = "raid"
        	mbtlbgroupnumber = GetNumSubgroupMembers()
    	elseif GetNumSubgroupMembers() > 0 then
        	mbtlbgroupsuffix = "party"
            mbtlbgroupnumber = GetNumSubgroupMembers()
    	end
    	
    else
    	
		if (GetNumRaidMembers() ~= 0) 
			then mbtlbgroupsuffix = "raid"
				 mbtlbgroupnumber = GetNumRaidMembers()
		elseif (GetNumPartyMembers() ~= 0)
			then mbtlbgroupsuffix = "party"
				 mbtlbgroupnumber = GetNumPartyMembers()
		end
	end
    
    if (UnitGUID("target") == targetguid)
        then mbtlbtargetsuffix = "target"
    elseif (UnitGUID("mouseover") == targetguid)
        then mbtlbtargetsuffix = "mouseover"
    elseif (UnitGUID("focus") == targetguid)
        then mbtlbtargetsuffix = "focus"
    end
    
    if MBTlvbID == 112948 then
    
        table.insert(MBTrackertable, {targetguid, targetname, select(1,GetSpellCooldown(MBTlvb)) + select(2,GetSpellCooldown(MBTlvb)), select(2,GetSpellCooldown(MBTlvb)), GetRaidTargetIndex(mbtlbtargetsuffix)})
        
    else
    
        if mbtrackerimpacttimer and ((mbtrackerimpacttimer + 1) >= GetTime())
            then local a12,b12,c12,d12,e12,f12,g12,h12,i12,j12,k12 = UnitAura("target", MBTlvb, nil, "PLAYER HARMFUL") --print(1)------------
                 for z = 1, #MBTrackertable do
                 
                    if ((MBTrackertable[z])[1] == targetguid) 
                        then (MBTrackertable[z])[3] = g12;
                             (MBTrackertable[z])[4] = f12;
                             (MBTrackertable[z])[5] = nil
                             mbtlbtablerefresh = 1
                             break
                    end 
                 end
                 
                 if (mbtlbtablerefresh == 1) then
                 else table.insert(MBTrackertable, {targetguid, targetname, g12, f12})
                 end
                 
                 mbtlbraidcheck = 1
            
        elseif mbtlbtargetsuffix and (UnitGUID(mbtlbtargetsuffix) == targetguid)
            then local a12,b12,c12,d12,e12,f12,g12,h12,i12,j12,k12 = UnitAura(mbtlbtargetsuffix, MBTlvb, nil, "PLAYER HARMFUL") --print(2)------------
                 for z = 1, #MBTrackertable do
                 
                    if ((MBTrackertable[z])[1] == targetguid) 
                        then (MBTrackertable[z])[3] = g12;
                             (MBTrackertable[z])[4] = f12;
                             (MBTrackertable[z])[5] = GetRaidTargetIndex(mbtlbtargetsuffix)
                             mbtlbtablerefresh = 1
                             break
                    end 
                 end
                 
                 if (mbtlbtablerefresh == 1) then
                 else table.insert(MBTrackertable, {targetguid, targetname, g12, f12, GetRaidTargetIndex(mbtlbtargetsuffix)})
                 end
                 
                 mbtlbraidcheck = 1
            
        elseif mbtlbgroupsuffix then --print(3)------------
            for i = 1, mbtlbgroupnumber do -- first we check if a raid or party members target the bomb's target to have an accurate expiration time with UnitAura
                
                if (UnitGUID(mbtlbgroupsuffix..i.."-target") == targetguid) 
                    then local a12,b12,c12,d12,e12,f12,g12,h12,i12,j12,k12 = UnitAura(mbtlbgroupsuffix..i.."-target", MBTlvb, nil, "PLAYER HARMFUL")
                         
                         for z = 1, #MBTrackertable do
                         
                            if ((MBTrackertable[z])[1] == targetguid) 
                                then (MBTrackertable[z])[3] = g12;
                                     (MBTrackertable[z])[4] = f12;
                                     (MBTrackertable[z])[5] = GetRaidTargetIndex(mbtlbgroupsuffix..i.."-target")
                                     mbtlbtablerefresh = 1
                                     break
                            end 
                         end
                         
                         if (mbtlbtablerefresh == 1) then
                         else table.insert(MBTrackertable, {targetguid, targetname, g12, f12, GetRaidTargetIndex(mbtlbgroupsuffix..i.."-target")})
                         end
                         
                         mbtlbraidcheck = 1
                    
                end
            end
        end
        
        if (mbtlbraidcheck == 0) -- info with UnitAura have been collected, skipping this part.
            then for z = 1, #MBTrackertable do -- no raid members targetting the bomb target so using GetTime from event fired and 12 secs as duration
                     
                    if ((MBTrackertable[z])[1] == targetguid) 
                        then if MBTlvbID == 112948 then
                                (MBTrackertable[z])[3] = select(1,GetSpellCooldown(MBTlvb)) + select(2,GetSpellCooldown(MBTlvb))
                             else (MBTrackertable[z])[3] = (eventgettime + 12)
                             end

                             if MBTlvbID == 112948 then
                                (MBTrackertable[z])[4] = select(2,GetSpellCooldown(MBTlvb))
                             else (MBTrackertable[z])[4] = 12;
                             end
                             (MBTrackertable[z])[5] = nil
                             mbtlbtablerefresh = 1
                             break
                    end 
                 end
                         
                 if (mbtlbtablerefresh == 1) then
                 else table.insert(MBTrackertable, {targetguid, targetname, (eventgettime + 12), 12, nil})
                 end
        end
        
        for i = #MBTrackertable,1,-1 do
            if MBTrackertable[i] and (((MBTrackertable[i])[1] == 2120) or ((MBTrackertable[i])[1] == 88148)) then 
                table.insert(MBTrackertable,{(MBTrackertable[i])[1],(MBTrackertable[i])[2],(MBTrackertable[i])[3],(MBTrackertable[i])[4]});
                table.remove(MBTrackertable,i);
            end
        end
    end
end

local function MBTrackerUpdate()
    
    if #MBTrackertable == 0 and mbtrackerenablemax == 0 then 

        mbtrackerenablemax = 1
        MBTrackerCreateBombRow (1)
        
    elseif #MBTrackertable == 0 and mbtrackerenableclean == false and mbtrackerenablemax ~= 0 then 

	    for i = 1,mbtrackerenablemax do 
            
           	if not _G["MBTrack"..i] then
                MBTrackerCreateBombRow (i)
            end

    		_G["MBTrack"..i.."InfoText"]:SetText("")
            _G["MBTrack"..i.."InfoTimer"]:SetText("")
            _G["MBTrack"..i.."Bar"]:Hide()
            _G["MBTrack"..i.."InfoTarget"]:SetTexture("")                
            _G["MBTrack"..i.."InfoSymbol"]:SetTexture("")
        end

   		MBTrack1InfoText:SetText("-- no bomb --")
        mbtrackerenableheight = 9
        mbtrackerenableclean = true
        
    elseif #MBTrackertable ~= 0 then
    	
    	mbtrackerenableclean = false
    	mbtrackerenableheight = 0
    	
    	if #MBTrackertable > mbtrackerenablemax then
    		mbtrackerenablemax = #MBTrackertable
    	end
    	
    	for i = 1, mbtrackerenablemax do 
            
           	if not _G["MBTrack"..i] then
                MBTrackerCreateBombRow (i)
            end
            
			if MBTrackertable[i] and (MBTrackertable[i])[3] and ((MBTrackertable[i])[3] + 2) <= GetTime() 
				then table.remove(MBTrackertable,i)
			end
		
			if (#MBTrackertable == 1) and (UnitGUID("target") == (MBTrackertable[1])[1]) and (mbtrackersettingstable["mbtlbtarget"] == false)
				then _G["MBTrack"..i.."InfoText"]:SetText("")
					 _G["MBTrack"..i.."InfoTimer"]:SetText("")
					 _G["MBTrack"..i.."Bar"]:Hide()
					 _G["MBTrack"..i.."InfoTarget"]:Hide()
					 _G["MBTrack"..i.."InfoSymbol"]:Hide()
					 MBTrackerFrame:Hide() --print("1")
			elseif MBTrackertable[i] and (MBTrackertable[i])[3]
				then _G["MBTrack"..i.."InfoText"]:SetText((MBTrackertable[i])[2])
					 mbtlbtimer = (-1*(GetTime()-(MBTrackertable[i])[3]))
					 
					 if (MBTrackertable[i])[4] and (mbtlbtimer >= mbtrackersettingstable["mbtrackertimervalue"]) then -- condition when timer is with more than 2 seconds left
						 _G["MBTrack"..i.."InfoTimer"]:SetText(format("|cff00ff00%.1f|r",mbtlbtimer))
						 _G["MBTrack"..i.."Bar"]:Show()
						 _G["MBTrack"..i.."Bar"]:SetValue(100*(mbtlbtimer/(MBTrackertable[i])[4]))
						 _G["MBTrack"..i.."Bar"]:SetStatusBarColor((mbtrackersettingstable["barcolornormal"])[1],(mbtrackersettingstable["barcolornormal"])[2],(mbtrackersettingstable["barcolornormal"])[3],(mbtrackersettingstable["barcolornormal"])[4])
					 elseif (MBTrackertable[i])[4] and (mbtlbtimer <= mbtrackersettingstable["mbtrackertimervalue"]) and (mbtlbtimer >= 0) then -- condition when timer is with less than 2 seconds left
						 _G["MBTrack"..i.."InfoTimer"]:SetText(format("|cffff0000%.1f|r",mbtlbtimer))
						 _G["MBTrack"..i.."Bar"]:Show()
						 _G["MBTrack"..i.."Bar"]:SetValue(100*(mbtlbtimer/(MBTrackertable[i])[4]))
						 _G["MBTrack"..i.."Bar"]:SetStatusBarColor(unpack(mbtrackersettingstable["barcolorwarning"]))
					 elseif (mbtlbtimer <= 0) then
						 table.remove(MBTrackertable,i)
					 end
					 
					 if MBTrackertable[i] and (MBTrackertable[i])[5] then 
						_G["MBTrack"..i.."InfoSymbol"]:SetTexture("Interface\\TARGETINGFRAME\\UI-RaidTargetingIcon_"..(MBTrackertable[i])[5])
					 else _G["MBTrack"..i.."InfoSymbol"]:SetTexture("")
					 end
					 
					 if MBTrackertable[i] and (UnitGUID("target") == (MBTrackertable[i])[1]) and mbtrackersettingstable["mbtrackertarget"] == true then
						_G["MBTrack"..i.."InfoTarget"]:SetTexture("Interface\\AddOns\\MageBombTracker\\Images\\Combustion_target")
					 else _G["MBTrack"..i.."InfoTarget"]:SetTexture("")
					 end
					 
					 mbtrackerenableheight = mbtrackerenableheight + 9
					 
			else 
				 _G["MBTrack"..i.."InfoText"]:SetText("")
				 _G["MBTrack"..i.."InfoTimer"]:SetText("")
				 _G["MBTrack"..i.."Bar"]:Hide()
				 _G["MBTrack"..i.."InfoTarget"]:SetTexture("")
				 _G["MBTrack"..i.."InfoSymbol"]:SetTexture("")
			end
		end
    end

    MBTrackerBorderFrame:SetHeight(mbtrackerenableheight + 11)
    
end
 
-------------------------------------
-- Autohide function
function MBTrackerAutohide()

	local mbtrackercombat = UnitAffectingCombat("player")
	
    if mbtrackersettingstable["mbtrackerenable"] == true and select(2, UnitClass("player")) == "MAGE" then
        
        if mbtrackersettingstable["mbtrackerautohide"] == 1 then -- condition when autohide is disabled
            
            MBTrackerFrame:Show()
            
        elseif mbtrackercombat == nil and mbtrackersettingstable["mbtrackerautohide"] ~= 1 then -- condition when not in combat
            
            MBTrackerFrame:Hide()
            
        elseif #MBTrackertable == 0 and mbtrackersettingstable["mbtrackerautohide"] == 3 then -- condition when in combat
            
            MBTrackerFrame:Hide()
            
        elseif mbtrackercombat == 1 then -- condition when in combat
            
            MBTrackerFrame:Show()
            
        end
        
    else MBTrackerFrame:Hide()
        
    end
    
end


-------------------------------------------------------------------------------------------------------	
-------------------------------------------------------------------------------------------------------	
-------------------------------- ON_EVENT FUNCTION ----------------------------------------------------

function MBTracker_OnEvent(self, event, ...)

    if (event == "PLAYER_LOGIN") then
    	               
	    if (MBTrackerFrame:GetFrameLevel() == 0) then
	        MBTrackerFrame:SetFrameLevel(1) -- fix when frame is at FrameLevel 0
	    end
	    
	    if (mbtrackersettingstable["mbtrackerchat"]==true) then 
	    	ChatFrame1:AddMessage(MBTrackerLoc["startup"]) 
	    end
    
-------------------------------
--Frame lock check on startup
        if (mbtrackersettingstable["mbtrackerlock"] == false) 
	 		then MBTrackerFrame:EnableMouse(true)
        elseif (mbtrackersettingstable["mbtrackerlock"] == true) 
	    	then MBTrackerFrame:EnableMouse(false)
        end	
        
        MBTrackerLanguageCheck()
	    MBTrackerScale (mbtrackersettingstable["mbtrackerscale"]) -- Scale check on startup
	    MBTrackerFrameresize() -- MBTracker Frame size check on startup    
	    
    elseif event == "ACTIVE_TALENT_GROUP_CHANGED" or event == "PLAYER_TALENT_UPDATE" then
        
        MBTrackerBombChecker ()
  	    MBTrackerFrameresize() 

-------------------------------
--Combat log events checks
    elseif (event=="COMBAT_LOG_EVENT_UNFILTERED") then

    	timestamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, spellId, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, critical = select(1, ...)
            
            if (sourceName == UnitName("player")) and mbtrackersettingstable["mbtrackerenable"] == true then --print(spellId,event)
                
                if (mbtrackersettingstable["mbtrackerrefreshmode"] == true) then --print(spellId,event,amount)
                    
                    
                    if (event == "SPELL_AURA_REFRESH") and (spellId == MBTlvbID) then 
                        
                        mbtlbrefresh = mbtlbrefresh + 1 
                        mbtpotentialrefresh = GetTime()
                        mbtrefreshdone = 0
                        mbtrefreshGUID = destGUID
                        mbtrefreshname = destName
                        
                        if spellId == 114923 then
                            
                            for i = 1,#MBTrackertable do --print((MBTrackertable[i])[3] - GetTime())
                                
                                if MBTrackertable[i] and ((MBTrackertable[i])[1] == destGUID) and (MBTrackertable[i])[3] - GetTime() < 1 then
                                    
                                    mbtpotentialrefresh = 0
                                    mbtlbrefresh = mbtlbrefresh - 1 
                                    break
                                    
                                end
                            end
                        end
                                                                        
                    elseif (event == "SPELL_MISSED") and (spellId == MBTlvbID) then 
                        
                        P1aySoundFile("Sound\\Spells\\SimonGame_Visual_BadPress.wav")
                        print(format(MBTrackerLoc["lbmiss"],destName))
                        
                    elseif (spellId == 44461) and mbtrefreshGUID == destGUID then
                        
                        if abs(mbtpotentialrefresh - GetTime()) < 0.5 then 
                            
                            mbtpotentialrefresh = 0
                            mbtlbrefresh = mbtlbrefresh - 1 
                            
                        end
                    end
                end

				-------------------------------------------
				-- Living Bomb tracking 
                if (mbtrackersettingstable["mbtrackerenable"] == true) and (spellId == MBTlvbID) then 
                	if (event == "SPELL_AURA_APPLIED") or (event == "SPELL_AURA_REFRESH") then
                    
                		MBTrackerLBauratracker(destGUID, destName, GetTime())
                        MBTrackerAutohide()
                             
                	elseif (event == "SPELL_AURA_REMOVED") and spellId ~= 112948 then
                    
                		for i = 1,#MBTrackertable do
                 
							if MBTrackertable[i] and ((MBTrackertable[i])[1] == destGUID) 
                 				then table.remove(MBTrackertable,i)
                                    break
                 		 	end
                 		end
                        
                        MBTrackerAutohide()
                        
                	end
                end
                
                -- Impact and inferno blast manager for bomb tracking
                if (spellId == 2136) or (spellId == 108853) and (event == "SPELL_CAST_SUCCESS") -- successful impact cast
                    then mbtrackerimpacttimer = GetTime()
                elseif (spellId == 2136) or (spellId == 108853) and (event == "SPELL_MISSED")
                    then mbtrackerimpacttimer = nil
                end

				-------------------------------------------
				-- FlameStrike tracking 
			    if  (mbtrackersettingstable["mbtrackerflamestrike"] == true) or (spellId == 2120) and (spellId == 88148) then 
			    	if (event == "SPELL_DAMAGE") or (event == "SPELL_CAST_SUCCESS")
						then mbtlbtablerefresh = 0
							 for z = 1, #MBTrackertable do
			               
					    		 if ((MBTrackertable[z])[1] == spellId) 
					            	then (MBTrackertable[z])[3] = (GetTime() + 8);
					                     (MBTrackertable[z])[4] = 8;
					                     (MBTrackertable[z])[5] = nil
					                     mbtlbtablerefresh = 1
					                     break
					             end 
					         end
			                   
					         if (mbtlbtablerefresh == 1) then
					         elseif (spellId == 2120) 
					         	then table.insert(MBTrackertable, {spellId, MBTrackerLabel["flamestrike"], (GetTime() + 8), 8, nil})
					         elseif (spellId == 88148) 
					         	then table.insert(MBTrackertable, {spellId, MBTrackerLabel["blastwave"], (GetTime() + 8), 8, nil})
					         end
					end
				end
						
            end
                
-------------------------------------------
-- Start and End of fight events 
    elseif (event == "PLAYER_REGEN_DISABLED") then 
    	
        MBTrackerAutohide()
        		    
    elseif (event == "PLAYER_REGEN_ENABLED") then 
    	    
    	if (mbtlbrefresh >= 1) then
        	print(format(MBTrackerLoc["lbreport"],mbtlbrefresh))
        	mbtlbrefresh = 0
        end
    		        
        table.wipe(MBTrackertable) -- cleaning multiple Bomb tracker table when leaving combat
        MBTrackerAutohide()
            
    end

end
	




	
-------------------------------------------------------------------------------------------------------	
-------------------------------------------------------------------------------------------------------	
-------------------------------- ON_UPDATE FUNCTION ----------------------------------------------------

function MBTracker_OnUpdate(self, elapsed)
    self.TimeSinceLastUpdate = (self.TimeSinceLastUpdate or 0) + elapsed;
 
		if (self.TimeSinceLastUpdate > MBTracker_UpdateInterval) then
            local time = GetTime()   
            
--------------------------------
-- multiple Living Bomb tracking
    		if (mbtrackersettingstable["mbtrackerenable"] == true) or (mbtrackersettingstable["mbtrackerflamestrike"] == true) then
    			MBTrackerUpdate()
    		end

            if (mbtrackersettingstable["mbtrackerrefreshmode"] == true) and InCombatLockdown() == true then
            
                if abs(mbtpotentialrefresh + 1.6 - GetTime()) < 0.8 and mbtrefreshdone == 0 then
                    
                    print(format(MBTrackerLoc["lbrefresh"],mbtrefreshname))
                    mbtrefreshdone = 1
                end
            
            end

    		self.TimeSinceLastUpdate = 0

    end    
end


SLASH_MBTRACKERCONFIG1 = "/MageBombTracker"

SlashCmdList["MBTRACKERCONFIG"] = function(msg)

	if msg == "" or  msg == "help" or  msg == "?" or msg == "config" then
		 InterfaceOptionsFrame_OpenToCategory("MageBombTracker")
		 if (mbtrackersettingstable["mbtrackerchat"]==true) then print(format(MBTrackerLoc["slashcomm"])) end
	else
		 InterfaceOptionsFrame_OpenToCategory("MageBombTracker")
		 if (mbtrackersettingstable["mbtrackerchat"]==true) then print(format(MBTrackerLoc["slashcomm"])) end
	end

end